#include "lib.h"
#include <stdio.h>

int flag[256];
static int debug = 0;
static int verbose =0;

void
copy(char *src, char *dst)
{
  int srcfd, dstfd;
  static char buffer[4096];
  int n, r ;

  if (verbose)
    fprintf(STDOUT_FILE, "copying %s to %s\n", src, dst);
  if (!isfile(src) || isdir(dst))
    panic("Can't copy %s to %s\n", src, dst);
  if ((srcfd = open(src, O_RDONLY)) < 0)
    panic("open %s: %e", src, srcfd);
  if ((dstfd = open(dst, O_RDWR|O_CREAT|O_EXCL)) < 0)
    panic("open %s: %e", dst, dstfd);
    
  while ((n = readn(srcfd, buffer, sizeof buffer)) > 0) {
    if ((r = write(dstfd, buffer, n)) < 0)
      panic("Failing to write %d bytes into %s\n", n, dst);
  }
  close(srcfd);
  close(dstfd);
}

static void 
copy_to_dir(char *file, char *dir)
{
  static char buffer[MAXNAMELEN];

  strcpy(buffer, dir);
  strcat(buffer, "/");
  strcat(buffer, file);
  copy(file, buffer);
}


void
usage(void)
{
	fprintf(1, "usage: cp srcfile dstfile \n");
	fprintf(1, "       cp src1 [src2...] dstdir \n");
	exit();
}

void
umain(int argc, char **argv)
{
  int i;

	ARGBEGIN{
	case 'v':
		verbose = 1;
		break;
	default:
		usage();
		break;
	}ARGEND
	   
	   if (debug)
	     fprintf(STDERR_FILE, "cp: begin\n");
	if (argc < 2)
	  usage();
	if (isdir(argv[argc-1])) {
	  for (i=0; i<argc-1; i++) {
	    copy_to_dir(argv[i], argv[argc-1]);
	  }
	} else {
	  if (argc != 2)
	    usage();
	  copy(argv[0],argv[1]);
	}
}

