#include "lib.h"
#include <stdio.h>

int flag[256];
static int debug = 0;

static char
get_status(u_int status)
{
  switch (status) {
  case ENV_FREE:
    return 'F';
  case ENV_RUNNABLE:
    return 'R';
  case ENV_NOT_RUNNABLE:
    return 'W';
  case ENV_ZOMBIE:
    return 'Z';
  default:
    return ' ';
  }
}

void
usage(void)
{
  fprintf(1, "usage: ps\n");
  exit();
}

void
umain(int argc, char **argv)
{
  struct Env *env;

  int i;

	ARGBEGIN{
	default:
	  usage();
	}ARGEND
	   
	    fprintf(STDOUT_FILE, "   PID      PPID     status  NAME\n");
	   for (i=0; i< NENV; i++) {
	     if (envs[i].env_status != ENV_FREE) {
	       env = &(envs[i]);
	       fprintf(STDOUT_FILE,"%6d    %6d       %c     %s\n", env->env_id,
		       env->env_parent_id, get_status(env->env_status), env->env_name);
	     }
	   }
}

